'Script by Florian Rossmark
'Version 2.0

Const SQLConnection = "Provider=SQLOLEDB.1;Server=YOURSERVER\SQLEXPRESS;Database=ITPrinterManagement;Trusted_Connection=Yes;"

Dim WSHShell
Set WSHShell = CreateObject("WScript.Shell")

Dim con, rs, rs2
Set con = CreateObject("ADODB.Connection")
Set rs = CreateObject("ADODB.Recordset")
Set rs2 = CreateObject("ADODB.Recordset")

Dim objWMI
Set objWMI = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2") 

Dim bolNetwork 'Boolean - used in a bit version

Dim UserID, ComputerID, PrinterID, LogNotes

con.Open SQLConnection

	rs.Open "SELECT TOP 1 * FROM tblPrinterMgmtUsers WHERE UserName LIKE '" & TRIM(WSHShell.ExpandEnvironmentStrings("%UserName%")) & "'", con, 2, 2
		If rs.EOF Then
			rs.AddNew
				rs("UserName") = TRIM(WSHShell.ExpandEnvironmentStrings("%UserName%"))
			rs.Update
			rs.Requery
		End If
		UserID = rs("ID")
	rs.Close
	rs.Open "SELECT TOP 1 * FROM tblPrinterMgmtComputer WHERE ComputerName LIKE '" & TRIM(WSHShell.ExpandEnvironmentStrings("%ComputerName%")) & "'", con, 2, 2
		If rs.EOF Then
			rs.AddNew
				rs("ComputerName") = TRIM(WSHShell.ExpandEnvironmentStrings("%ComputerName%"))
				rs("OS") = GetOS.Version
			rs.Update
			rs.Requery
		Else
			rs("OS") = GetOS.Version
			rs.Update
		End If
		ComputerID = rs("ID")
	rs.Close	

	'section to check for user / machine enforced printers
	'User
	rs.Open "SELECT * FROM tblPrinterMgmtUserToPrinter WHERE Active = 1 AND UserID = " & UserID, con, 2, 2
		If not rs.EOF Then
			Do While Not rs.EOF
				LogNotes = ""
				PrinterID = 0
				If CInt(Split(GetOS.Version,".")(0)) < 6 Then '2003 R2 or XP or older...
					If rs("PrinterIDXP") > 0 Then
						PrinterID = rs("PrinterIDXP")
						rs2.Open "SELECT TOP 1 * FROM tblPrinterMgmtPrinter WHERE ID = " & rs("PrinterIDXP"), con, 2, 2
							If Not rs2.EOF Then
								'If rs2("ControlStatusID") = 1 Then
									LogNotes = "XP or earlier OS - Enforcing User Printer connection to '" & rs2("PrinterNamePath") & "'"
									PrinterConnect rs2("PrinterNamePath")
								'End If
							End If
						rs2.Close
					End If
				Else 'Vista, 7, 8, 10 etc.. 
					If rs("PrinterID") > 0 Then
						PrinterID = rs("PrinterID")
						rs2.Open "SELECT TOP 1 * FROM tblPrinterMgmtPrinter WHERE ID = " & rs("PrinterID"), con, 2, 2
							If Not rs2.EOF Then
								'If rs2("ControlStatusID") = 1 Then
									LogNotes = "Enforcing User Printer connection to '" & rs2("PrinterNamePath") & "'"
									PrinterConnect rs2("PrinterNamePath")
								'End If
							End If
						rs2.Close
					End If			
				End If
				If Len(LogNotes) > 0 Then
					rs2.Open "SELECT TOP 1 * FROM tblPrinterMgmtUserComputerPrinterLog WHERE UserID = " & UserID & " AND ComputerID = " & ComputerID & " AND PrinterID = " & PrinterID, con, 2, 2
						If rs2.EOF Then
							rs2.AddNew
								rs2("UserID") = UserID
								rs2("ComputerID") = ComputerID
								rs2("PrinterID") = PrinterID
						End If
						rs2("LogNotes") = LogNotes
						rs2("LogDateTime") = Now()
						rs2.Update
					rs2.Close					
				End If
				rs.MoveNext
			Loop
		End If
	rs.Close
	
	'Computer
	rs.Open "SELECT * FROM tblPrinterMgmtComputerToPrinter WHERE Active = 1 AND ComputerID = " & ComputerID, con, 2, 2
		If not rs.EOF Then
			Do While Not rs.EOF
				LogNotes = ""
				PrinterID = 0
				If CInt(Split(GetOS.Version,".")(0)) < 6 Then '2003 R2 or XP or older...
					If rs("PrinterIDXP") > 0 Then
						PrinterID = rs("PrinterIDXP")
						rs2.Open "SELECT TOP 1 * FROM tblPrinterMgmtPrinter WHERE ID = " & rs("PrinterIDXP"), con, 2, 2
							If Not rs2.EOF Then
								'If rs2("ControlStatusID") = 1 Then
									LogNotes = "XP or earlier OS - Enforcing Computer Printer connection to '" & rs2("PrinterNamePath") & "'"
									PrinterConnect rs2("PrinterNamePath")
								'End If
							End If
						rs2.Close
					End If
				Else 'Vista, 7, 8, 10 etc.. 
					If rs("PrinterID") > 0 Then
						PrinterID = rs("PrinterID")
						rs2.Open "SELECT TOP 1 * FROM tblPrinterMgmtPrinter WHERE ID = " & rs("PrinterID"), con, 2, 2
							If Not rs2.EOF Then
								'If rs2("ControlStatusID") = 1 Then
									LogNotes = "Enforcing Computer Printer connection to '" & rs2("PrinterNamePath") & "'"
									PrinterConnect rs2("PrinterNamePath")
								'End If
							End If
						rs2.Close
					End If			
				End If
				If Len(LogNotes) > 0 Then
					rs2.Open "SELECT TOP 1 * FROM tblPrinterMgmtUserComputerPrinterLog WHERE UserID = " & UserID & " AND ComputerID = " & ComputerID & " AND PrinterID = " & PrinterID, con, 2, 2
						If rs2.EOF Then
							rs2.AddNew
								rs2("UserID") = UserID
								rs2("ComputerID") = ComputerID
								rs2("PrinterID") = PrinterID
						End If
						rs2("LogNotes") = LogNotes
						rs2("LogDateTime") = Now()
						rs2.Update
					rs2.Close					
				End If
				rs.MoveNext
			Loop
		End If
	rs.Close
	
	'Section to replace and remove printers - after user/computer specific
	Set colPrinters = objWMI.ExecQuery("Select * from Win32_Printer")
	For Each objPrinter in colPrinters
		LogNotes = ""
		If Not Len(objPrinter.PortName) = 5 And Not Left(objPrinter.PortName,2) = "TS" Then
			If objPrinter.Network Then bolNetwork = 1 Else bolNetwork = 0
			rs.Open "SELECT TOP 1 * FROM tblPrinterMgmtPrinter WHERE NetworkPrinter = " & bolNetwork & " AND PrinterNamePath LIKE '" & TRIM(objPrinter.DeviceID) & "'", con, 2, 2
				If rs.EOF Then
					rs.AddNew
						rs("NetworkPrinter") = bolNetwork
						rs("PrinterNamePath") = TRIM(objPrinter.DeviceID)
					rs.Update
					rs.Requery
				Else 'printer exists - there might be a status replace or delete
					If objPrinter.Network Then
						If rs("ControlStatusID") = 2 Then 'delete
							LogNotes = "printer delete attempted"
							'delete
							PrinterDelete objPrinter
						ElseIf rs("ControlStatusID") = 3 Then 'replace
							If CInt(Split(GetOS.Version,".")(0)) < 6 Then '2003 R2 or XP or older...
								LogNotes = "XP or earlier OS - printer replace attempted with"
								If rs("ReplaceWithIDXP") > 0 Then
									rs2.Open "SELECT TOP 1 * FROM tblPrinterMgmtPrinter WHERE ID = " & rs("ReplaceWithIDXP"), con, 2, 2
										If Not rs2.EOF Then
											If rs2("ControlStatusID") = 1 Then
												LogNotes = LogNotes & "'" & rs2("PrinterNamePath") & "'"
												'delete
												PrinterDelete objPrinter
												'connect
												PrinterConnect rs2("PrinterNamePath")
											Else
												LogNotes = LogNotes & " - replace printer status is remove or delete - deleting this printer as fallback method"
												'delete
												PrinterDelete objPrinter
											End If
										End If
									rs2.Close
								Else
									LogNotes = LogNotes & " - no replace printer defined"
								End If							
							Else 'Vista, 7, 8, 10 etc.. 							
								LogNotes = "printer replace attempted with"
								If rs("ReplaceWithID") > 0 Then
									rs2.Open "SELECT TOP 1 * FROM tblPrinterMgmtPrinter WHERE ID = " & rs("ReplaceWithID"), con, 2, 2
										If Not rs2.EOF Then
											If rs2("ControlStatusID") = 1 Then
												LogNotes = LogNotes & "'" & rs2("PrinterNamePath") & "'"
												'delete
												PrinterDelete objPrinter
												'connect
												PrinterConnect rs2("PrinterNamePath")
											Else
												LogNotes = LogNotes & " - replace printer status is remove or delete - deleting this printer as fallback method"
												'delete
												PrinterDelete objPrinter
											End If
										End If
									rs2.Close
								Else
									LogNotes = LogNotes & " - no replace printer defined"
								End If
							End If
						End If
					Else
						'local printer
					End If
				End If
				PrinterID = rs("ID")
			rs.Close
			rs.Open "SELECT TOP 1 * FROM tblPrinterMgmtUserComputerPrinterLog WHERE UserID = " & UserID & " AND ComputerID = " & ComputerID & " AND PrinterID = " & PrinterID, con, 2, 2
				If rs.EOF Then
					rs.AddNew
						rs("UserID") = UserID
						rs("ComputerID") = ComputerID
						rs("PrinterID") = PrinterID
				End If
				If Len(Trim(LogNotes)) > 0 Then rs("LogNotes") = LogNotes
				rs("LogDateTime") = Now()
				rs.Update
			rs.Close
		End If
	Next
	
con.Close

Set objWMI = Nothing

Set rs2 = Nothing
Set rs = Nothing
Set con = Nothing

Set WSHShell = Nothing

Sub PrinterDelete(objPrinter) 
	If objPrinter.Network Then
		Set objNetwork = CreateObject("WScript.Network") 
			objNetwork.RemovePrinterConnection objPrinter.DeviceID
		Set objNetwork = Nothing
	End If
End Sub

Sub PrinterConnect(UNCPath)
	On Error Resume Next
		Set objNetwork = CreateObject("WScript.Network") 
			objNetwork.AddWindowsPrinterConnection UNCPath
		Set objNetwork = Nothing
	On Error Goto 0
End Sub

Function GetOS()
	Dim objWMIOSQuery
	Set objWMIOSQuery = objWMI.ExecQuery("Select * from Win32_OperatingSystem")
	For Each objOS in objWMIOSQuery 'there will be just one anyways
		Set GetOS = objOS
		Exit For
	Next
	Set objWMIOSQuery = Nothing
End Function